# How to contribute

First off, thank you for considering contributing to SectionedRecyclerViewAdapter library.

Following these guidelines helps to communicate that you respect the time of the developers managing and developing this open source project. In return, they should reciprocate that respect in addressing your issue, assessing changes, and helping you finalize your pull requests.

There are many ways to contribute:
- improving the documentation;
- submitting bug reports;
- fixing bugs reported;
- answering questions from the [issue tracker](https://github.com/luizgrp/SectionedRecyclerViewAdapter/issues) or [Stack Overflow](https://stackoverflow.com/questions/tagged/sectionedrecyclerviewadapter);
- submitting feature requests;
- writing code which can be incorporated into the library itself;

Goal
----------------
The goal of SectionedRecyclerViewAdapter library is to provide a simple way of grouping repeatable items into sections. Each section can have a header and/or footer and can have their states changed individually.

Support questions
----------------

Use the issue tracker for support questions as last resource. Please use [Stack Overflow](https://stackoverflow.com/questions/tagged/sectionedrecyclerviewadapter) as first option.

Reporting issues
----------------

- Describe what you expected to happen.
- Describe what actually happened. Include the full traceback if there was an exception.
- If possible, include a [minimal, complete, and verifiable example](https://stackoverflow.com/help/mcve) to help
  us identify the issue. This also helps check that the issue is not with your
  own code.
- Provide the library version used. If possible, check if this issue is already fixed in the repository.

Submitting pull requests
----------------

Before submitting a pull request, add your suggestion to the [issue tracker](https://github.com/luizgrp/SectionedRecyclerViewAdapter/issues), following the template available.
